/*
Copyright (c) 2001 Dan Vernon

This program is free software; you can redistribute it and/or modify it under the terms 
of the GNU General Public License as published by the Free Software Foundation; either 
version 2 of the License, or (at your option) any later version. This program is 
distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details. You should have received a copy of the GNU
General Public License along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

// EventQueue.h: interface for the CEventQueue class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EVENTQUEUE_H__CBBBA78B_89F5_4BED_B18E_47057C3F25C0__INCLUDED_)
#define AFX_EVENTQUEUE_H__CBBBA78B_89F5_4BED_B18E_47057C3F25C0__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#pragma warning (disable : 4786) 
#endif // _MSC_VER > 1000

#include "innershell.h"

#include <list>
#include <queue>
#include <string>
using namespace std ;

class CEventQueue  
{
public:
	CEventQueue();
	virtual ~CEventQueue();

	DWORD size();
	void pushStatus(LPCSTR msg);
	void pushDebug(LPCSTR msg);
	void pushError(DWORD number, LPCSTR msg, LPCSTR src, LPCSTR func);
	void pushCommand(BYTE b1,BYTE b2,BYTE b3,BYTE b4,BYTE b5,BYTE disk,WORD sector,LPCSTR command,BYTE speedIndex);
	void pushDebugCommand(BYTE b1,BYTE b2,BYTE b3,BYTE b4,BYTE b5,BYTE disk,WORD sector,LPCSTR command,BYTE speedIndex);
	void popEvent();

private:
	queue<string*>* q; 
	HANDLE queueMutex;
	void push(string* s);
	string* pop();
};

#endif // !defined(AFX_EVENTQUEUE_H__CBBBA78B_89F5_4BED_B18E_47057C3F25C0__INCLUDED_)
