/*
Copyright (c) 2001 Dan Vernon

This program is free software; you can redistribute it and/or modify it under the terms
of the GNU General Public License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version. This program is
distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details. You should have received a copy of the GNU
General Public License along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

// Shell.cpp : Implementation of the Shell class

#include "Shell.h"

#include "innerShell.h"

/////////////////////////////////////////////////////////////////////////////
// Shell

Shell::Shell()
{
	innerShell_init(this);
}
Shell::~Shell()
{
	innerShell_destroy();
}

/////////////////////////////////////////////////////////////////////////////
// Event firing methods (called by innerShell)
//
void Shell::Command(BYTE b1,BYTE b2,BYTE b3,BYTE b4,BYTE b5,BYTE disk,WORD sector,LPCSTR command)
{
	printf("\n%02x %02x %02x %02x %02x",b1,b2,b3,b4,b5);
	if (disk<=SIO_MAX_DISKS && disk>=1) printf(" [D%d: %s sector %d]",disk,command,sector);
}
void Shell::Status(LPCSTR msg)
{
	printf(" %s",msg);
}
void Shell::Debug(LPCSTR msg)
{
	printf(" <%s>",msg);
}
void Shell::Error(LONG number, LPCSTR msg)
{
	printf("\nerror %d: %s\n",number,msg);
}
