/*
Copyright (c) 2001 Dan Vernon

This program is free software; you can redistribute it and/or modify it under the terms
of the GNU General Public License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version. This program is
distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details. You should have received a copy of the GNU
General Public License along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

// sioPort.cpp: implementation of the CSIOPort class.
//
//////////////////////////////////////////////////////////////////////

#ifdef WIN32
#include "windefines.h"
#else if __GNUC__
#include "gnuDefines.h"
#endif
#include "sioPort.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CSIOPort::CSIOPort()
{
	handleCom=NULL;
	portNumber=0;
	portOpened=false;
}

CSIOPort::~CSIOPort()
{
	closePort();
}

bool CSIOPort::setSerialPort(BYTE portNumber)
{
	if (portNumber!=this->portNumber)
		openPort(portNumber);
	return (handleCom!=NULL);
}

void CSIOPort::reportPortStatus(DWORD eventMask)
{
    DWORD fRING, fRLSD, fRXCHAR, fRXFLAG, fTXEMPTY;
    DWORD fBREAK, fCTS, fDSR, fERR, fRX80FULL;
    char szMessage[500];

	/*
    fCTS = EV_CTS & eventMask;
    fDSR = EV_DSR & eventMask;
    fERR = EV_ERR & eventMask;
    fRING = EV_RING & eventMask;
    fRLSD = EV_RLSD & eventMask;
    fBREAK = EV_BREAK & eventMask;
    fRXCHAR = EV_RXCHAR & eventMask;
    fRXFLAG = EV_RXFLAG & eventMask;
    fTXEMPTY = EV_TXEMPTY & eventMask;
    fRX80FULL = EV_RX80FULL & eventMask;
	*/

	szMessage[0]=NULL;
    strcat(szMessage, fCTS ? "cts " : "");
    strcat(szMessage, fDSR ? "dsr " : "");
    strcat(szMessage, fERR ? "err " : "");
    strcat(szMessage, fRING ? "ring " : "");
    strcat(szMessage, fRLSD ? "rlsd " : "");
    strcat(szMessage, fBREAK ? "break " : "");
    strcat(szMessage, fRXFLAG ? "rxflag " : "");
    strcat(szMessage, fRXCHAR ? "rxchar " : "");
    strcat(szMessage, fTXEMPTY ? "txempty " : "");
    strcat(szMessage, fRX80FULL ? "rx80full " : "");

	innerShell_debug("%s",szMessage);
}

bool CSIOPort::openPort(BYTE portNumber)
{
	LPCSTR src = "CSIOPort::openPort";
	if (portOpened) closePort();
	currentSpeed = baudRate;
	return true;
}


bool CSIOPort::clearError()
{
	return true;
}

void CSIOPort::closePort()
{
}

//whenever we get checksum errors, nuke the i/o buffers & start over
void CSIOPort::resetPort()
{
}

bool CSIOPort::doOverlappedComCrud(DWORD func, DWORD count, BYTE* chunk)
{
	LPCSTR src = "CSIOPort::doOverlappedComCrud";
	return true;
}

bool CSIOPort::readBytes(BYTE* chunk,DWORD ct)
{
}

bool CSIOPort::writeBytes(BYTE* chunk,DWORD ct)
{
}

bool CSIOPort::writeAck(BYTE byte)
{
}
