VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CSettings"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'Copyright (c) 2001 Dan Vernon
'
'This program is free software; you can redistribute it and/or modify it under the terms
'of the GNU General Public License as published by the Free Software Foundation; either
'version 2 of the License, or (at your option) any later version. This program is
'distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
'the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details. You should have received a copy of the GNU
'General Public License along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
Option Explicit

Private mDom As Object
Private mNode As Object
Private mBaseKey As String
Private mpath As String

Public Function Init(ByVal filepath As String, ByVal baseKey As String)
    mpath = filepath
    
    On Error Resume Next
    Set mDom = CreateObject("MSXML.DOMDocument")
    mDom.Load filepath
    On Error GoTo 0
    
    If mDom Is Nothing Then
        gUI.Error "The MSXML Parser cannot be loaded, session management is unavailable."
        Exit Function
    ElseIf mDom.parseError.errorCode = -2146697211 Then 'file not found
        CreateSettingsFile filepath
    ElseIf mDom.parseError.errorCode <> 0 Then
        Dim msg As String
        msg = "error parsing atari810.xml" & vbCrLf
        msg = msg & "at line " & mDom.parseError.Line & ", column " & mDom.parseError.linepos & vbCrLf
        msg = msg & mDom.parseError.reason
        MsgBox msg, vbCritical Or vbOKOnly, "Atari810"
    End If
    mBaseKey = baseKey
    Set mNode = GetNode(baseKey)
End Function

Private Function CreateDiskImageTemplate(description As String, sectorsize As Long, sectorcount As Long)
    Dim n As Object
    Set n = mDom.CreateElement("DiskImageTemplate")
    n.appendChild(mDom.CreateElement("Description")).Text = description
    n.appendChild(mDom.CreateElement("SectorSize")).Text = sectorsize
    n.appendChild(mDom.CreateElement("SectorCount")).Text = sectorcount
    mDom.documentElement.appendChild n
End Function

Private Function CreateSettingsFile(filepath As String)
'<SerialPortNumber>1</SerialPortNumber><StatusSize>8192</StatusSize><ShowDetails>False</ShowDetails><Height></Height><Width></Width>
    mDom.loadXML "<Atari810></Atari810>"
    CreateDiskImageTemplate "Atari 810 Single Density (720 sectors, 90KB)", 128, 720
    CreateDiskImageTemplate "Atari 1050 Enhanced Density (1040 sectors, 130KB)", 128, 1040
    CreateDiskImageTemplate "Indus GT Double Density (720 sectors, 180KB)", 256, 720
    CreateDiskImageTemplate "Double Sided - Double Density (1440 sectors, 360KB)", 256, 1440
    'CreateDiskImageTemplate "Black Box 3.5"" Double Density (???? sectors, 720KB)", 256, ????
    'CreateDiskImageTemplate "Black Box 3.5"" High Density (???? sectors, 1.44MB)", 256, ????
    CreateDiskImageTemplate "Hard Disk Single Density (32768 sectors, 4MB)", 128, 32768
    CreateDiskImageTemplate "Hard Disk Double Density (32768 sectors, 8MB)", 256, 32768
    CreateDiskImageTemplate "Hard Disk Single Density (65535 sectors, 8MB)", 128, 65535
    CreateDiskImageTemplate "Hard Disk Double Density (65535 sectors, 16MB)", 256, 65535
    mDom.Save filepath
End Function

Public Function LoadDiskImageDefs()
    Dim n As Object, m As Object
    Dim i As Long
    Dim nl As Object
    
    If mDom Is Nothing Then Exit Function
    
    On Error Resume Next
    i = UBound(DiskImageTemplates)
    On Error GoTo 0
    
    If i > 0 Then Exit Function
    
    Set nl = mDom.selectNodes("//Atari810/DiskImageTemplate")
    
    If nl.length Then
        ReDim DiskImageTemplates(nl.length - 1) As DISK_IMAGE_TEMPLATE
        
        For i = 0 To nl.length - 1
            On Error Resume Next
            Set m = nl.nextNode
            DiskImageTemplates(i).description = m.selectSingleNode("Description").Text
            DiskImageTemplates(i).sectorcount = m.selectSingleNode("SectorCount").Text
            DiskImageTemplates(i).sectorsize = m.selectSingleNode("SectorSize").Text
            On Error GoTo 0
        Next
    End If
End Function

Public Function ReadSetting(ByVal nodePath As String, ByVal default As String)
    Dim s As String
    On Error Resume Next
    s = mNode.selectSingleNode(nodePath).Text
    If Err.number Then s = default
    On Error GoTo 0
    ReadSetting = s
End Function

Public Function WriteSetting(ByVal nodePath As String, ByVal newValue As String)
    Dim n As Object
    On Error Resume Next
    Set n = mNode.selectSingleNode(nodePath)
    If n Is Nothing Then
        Set n = createNode(nodePath)
    End If
    On Error GoTo 0
    If Not n Is Nothing Then
        n.Text = newValue
    End If
End Function

Public Function Save()
    If Not mDom Is Nothing Then
        mDom.Save mpath
    End If
End Function

Public Function SessionNames() As String()
    Dim a() As String
    Dim nl As Object
    
    If mDom Is Nothing Then Exit Function
    
    Set nl = mDom.selectNodes("//Atari810/Session[Name != """ & DEFAULT_SESSION_KEY & """]")
    Dim i As Long
    If nl.length Then
        ReDim a(nl.length - 1) As String
        
        For i = 0 To nl.length - 1
            a(i) = nl.nextNode.selectSingleNode("Name").Text
        Next
    End If
    SessionNames = a
End Function

Public Function DeleteSession(ByVal name As String)
    Dim n As Object
    Dim xpath As String
    xpath = "Session[Name = """ & name & """]"
    Set n = mNode.selectSingleNode(xpath)
    If Not n Is Nothing Then
        mDom.documentElement.removeChild n
    End If
End Function

Public Function ReadSession(ByVal name As String)

    Dim n As Object
    Dim xpath As String
    xpath = "Session[Name = """ & name & """]"
    On Error Resume Next
    Set n = mNode.selectSingleNode(xpath)
    On Error GoTo 0
    If Not n Is Nothing Then
        Dim s As CSession
        Set s = New CSession
        s.Init n
        Dim i As Integer
        For i = 1 To SIO_MAX_DISKS
            gUI.sio.Release i
            If Len(s.diskPath(i)) Then
                On Error Resume Next
                gUI.sio.mount s.diskPath(i), i, s.readOnly(i)
                If Err.number Then gUI.Error "unable to load " & s.diskPath(i)
                On Error GoTo 0
            End If
        Next
    End If
End Function

Public Function SessionExists(ByVal name As String) As Boolean
    Dim n As Object
    Dim xpath As String
    xpath = "Session[Name = """ & name & """]"
    On Error Resume Next
    Set n = mNode.selectSingleNode(xpath)
    On Error GoTo 0
    SessionExists = Not n Is Nothing
End Function

Public Function WriteCurrentSession(ByVal name As String)
    Dim n As Object, m As Object
    Dim xpath As String
    xpath = "Session[Name = """ & name & """]"
    
    If mNode Is Nothing Then Exit Function
    
    On Error Resume Next
    Set n = mNode.selectSingleNode(xpath)
    On Error GoTo 0
    If n Is Nothing Then
        Set n = mDom.documentElement.appendChild(mDom.CreateElement("Session"))
    End If
    
    Dim c As Object
    For Each c In n.childNodes
        n.removeChild c
    Next
    
    n.appendChild(mDom.CreateElement("Name")).Text = name
    
    Dim i As Integer, path As String, readOnly As String
    For i = 1 To SIO_MAX_DISKS
        path = gUI.sio.diskPath(i)
        If Len(path) Then
            Set m = n.appendChild(mDom.CreateElement("Disk"))
            m.appendChild(mDom.CreateElement("Id")).Text = i
            m.appendChild(mDom.CreateElement("Path")).Text = path
            m.appendChild(mDom.CreateElement("ReadOnly")).Text = gUI.sio.diskReadOnly(i)
        End If
    Next
End Function

Public Function GetNode(ByVal nodePath As String) As Object
    Set GetNode = mDom.selectSingleNode(nodePath)
End Function

Private Function createNode(ByVal nodePath As String) As Object
    Set createNode = mDom.documentElement.appendChild(mDom.CreateElement(nodePath))
End Function
